#!/usr/bin/perl

#┌─────────────────────────────────
#│ Web Forum : admin.cgi - 2019/12/31
#│ Copyright (c) KentWeb
#│ http://www.kent-web.com/
#└─────────────────────────────────
# REBUILD(改造)
#┌─────────────────────────────────
#│  Web Forum v8.0P Multi : admin.cgi - 2022/11/27
#│  Edited by TRANSFORM Since 2012
#│  http://www.transformsite.com/
#└─────────────────────────────────

# モジュール宣言
use strict;
use CGI::Carp qw(fatalsToBrowser);
use vars qw(%in %cf);
use lib "./lib";
use CGI::Minimal;
use CGI::Session;
use Digest::SHA::PurePerl qw(sha256_base64);

# 外部ファイル取込み
require './init.cgi';
%cf = set_init();

# データ受理
CGI::Minimal::max_read_size($cf{maxdata});
my $cgi = CGI::Minimal->new;
error('容量オーバー') if ($cgi->truncated);
%in = parse_form($cgi);

# 認証
require "./lib/login.pl";
auth_login();

# 処理分岐
if ($in{mode} eq "edit" && $in{no}) { edit_data(); }
if ($in{mode} eq "dele" && $in{no}) { dele_data(); }
if ($in{mode} eq "lock" && $in{no}) { lock_data(); }
if ($in{mode} eq "solved" && $in{no}) { solved_data(); }
if ($in{list_data}) { list_data(); }
if ($in{pass_mgr}) { pass_mgr(); }

# メニュー画面
menu_html();

#-----------------------------------------------------------
#  メニュー画面
#-----------------------------------------------------------
sub menu_html {
	header("メニューTOP");

	print <<EOM;
<p></p>
<div class="center">選択ボタンを押してください。</div>
<div id="central">
<form action="$cf{admin_cgi}" method="post">
<input type="hidden" name="sid" value="$in{sid}">
<table class="panel">
<tr>
	<th colspan="2" width="250">処理メニュー</th>
</tr><tr>
	<td class="ta-c"><input type="submit" name="pass_mgr" value="選択" class="small button"></td>
	<td>パスワード管理</td>
</tr><tr>
	<td class="ta-c"><input type="submit" name="list_data" value="選択"></td>
	<td>記事リスト（編集/<font color="#FF9966">ロック開閉</font>/<font color="#79c06e">解決済</font>）</td>
</tr><tr>
	<td class="ta-c"><input type="button" value="選択"  onclick="javascript:window.location='$cf{bbs_cgi}'"></td>
	<td>掲示板へ戻る</td>
</tr><tr>
	<td class="ta-c"><input type="button" value="選択"  onclick="javascript:window.location='$cf{admin_cgi}'"></td>
	<td>ログアウト</td>
</tr>
</table>
</form>
</div>
</body>
</html>
EOM
	exit;
}

#-----------------------------------------------------------
#  記事リスト
#-----------------------------------------------------------
sub list_data {
	# ページ数
	my $page = $in{page} || '0';
	foreach ( $cgi->param() ) {
		if (/^page:(\d+)$/) {
			$page = $1;
			last;
		}
	}

	header("メニューTOP ＞ 記事リスト");
	back_btn();
	print <<EOM;
<div id="main">
<div id="main-in">
<div class="ttl">■ 記事リスト</div>
<ul class="sup-list">
<li>処理を選択して送信ボタンを押してください。
<li>ツリーの先頭記事を削除すると、ツリーごと一括削除されます。
<span style="color:#FF9966">
<li>スレッドロック開閉は親記事をロックすると返信記事もロックされます。
</span>
</ul>
<form action="$cf{admin_cgi}" method="post">
<input type="hidden" name="sid" value="$in{sid}">
<input type="hidden" name="list_data" value="1">
<div class="deal">
処理 
<input type="radio" name="mode" value="edit" checked>修正
<input type="radio" name="mode" value="dele">削除&nbsp;&nbsp;&nbsp;
<input type="radio" name="mode" value="lock">&nbsp;&nbsp;&nbsp;<font color="#FF9966">管理者ロック開閉</font>&nbsp;&nbsp;&nbsp;
<input type="radio" name="mode" value="solved"><font color="#79c06e">解決済(管理者) on/off</font>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
<input type="submit" value="送信する" style="color:rgb(38,38,38); background-color:rgb(255,197,86); border-width:1px; border-top-color:rgb(255,232,188); border-right-color:rgb(255,153,102); border-bottom-color:rgb(255,153,102); border-left-color:rgb(255,232,188); border-style:solid;">
</div><dl>
EOM

	my $i = 0;
	my $x = 0;
	open(IN,"$cf{logfile}") or &error("open err: $cf{logfile}");
	my $top = <IN>;
	while (<IN>) {
		my ($no,$re,$lx,$sub,$eml,$url,$nam,$date,$msg,$lt,$hos,$pw,$wr,$oya,$sml,$res,$e1,$w1,$h1,$key,$e2,$w2,$h2,$e3,$w3,$h3,$e4,$w4,$h4,$e5,$w5,$h5,$imgtxt1,$imgtxt2,$imgtxt3,$imgtxt4,$imgtxt5) = split(/<>/);
		if ($re == 0) { $i++; }
		next if ($i < $page + 1);
		next if ($i > $page + $cf{p_tree});

		my $sp;
		if ($lx) { $sp = "&nbsp;&nbsp;&nbsp;" x $lx; }
		#$msg =~ s/<br>/ /g;
		#if (length($msg) > 60) { $msg = substr($msg,0,58); $msg .= '..'; }

		print "<dt>";
		print "<hr color=\"#cce6ff\" size=\"0.5\">" if ($no == $oya);
		print qq|$sp<input type="checkbox" name="no" value="$no">\n|;

		# アイコン判断
		if ($lx != 0) {
			my $ico;
			if ($key eq '0') { $ico = 'res_lock'; }
			elsif ($key eq '2') { $ico = 'res_lock_user'; }
			elsif ($e1) { $ico = 'res_image'; }
			else { $ico = 'res_normal'; }
			print qq|<img src="$cf{icourl}/$cf{res_icon}->{$ico}" border="0" style="vertical-align:middle;">&nbsp;&nbsp;|;
		} else {
			my $ico;
			if ($key eq '0') { $ico = 0; }
			elsif ($key eq '2') { $ico = 2; }
			elsif ($e1) { $ico = 'image'; }
			else { $ico = 1; }
			print qq|<img src="$cf{icourl}/$cf{fld_icon}->{$ico}" border="0" style="vertical-align:middle;" alt="一括\表\示">&nbsp;&nbsp;|;
		}

		print qq|[$no] <b class="subcol">$sub</b> - <B>$nam</B> $date\n|;

		if ($key == 0) {
			print qq|[<font color="#FF9966">ロック中</font>]\n|;
		} elsif ($key == 2) {
			print qq|[<font color="#79c06e">解決済</font>]\n|;
		}

		# 引用部色変更
		if ($cf{ref_col}) {
			$msg =~ s/([\>]|^)(&gt;[^<]*)/$1<font color="$cf{ref_col}">$2<\/font>/g;
			$msg =~ s/([\>]|^)(&amp;gt;[^<]*)/$1<font color="$cf{ref_col}">$2<\/font>/g;
		}

			$msg = tag($msg);

		print qq|&nbsp;<span style="color:#FF9966">[$hos]</span></dt>\n|;
		print qq|<dd class="msg">$msg</dd><br />\n|;
	}
	close(IN);

	print "<dt><hr color=\"#8080c0\" size=\"0.5\"></dl>\n";

	my $next = $page + $cf{p_tree};
	my $back = $page - $cf{p_tree};

	if ($back >= 0) {
		print qq|<input type="submit" name="page:$back" value="前画面" style="color:rgb(38,38,38); background-color:rgb(255,197,86); border-width:1px; border-top-color:rgb(255,232,188); border-right-color:rgb(255,153,102); border-bottom-color:rgb(255,153,102); border-left-color:rgb(255,232,188); border-style:solid;">\n|;
	}
	if ($next < $i) {
		print qq|<input type="submit" name="page:$next" value="次画面" style="color:rgb(38,38,38); background-color:rgb(255,197,86); border-width:1px; border-top-color:rgb(255,232,188); border-right-color:rgb(255,153,102); border-bottom-color:rgb(255,153,102); border-left-color:rgb(255,232,188); border-style:solid;">\n|;
	}

	print <<EOM;
</form>
</div></div>
</body>
</html>
EOM
	exit;
}

#-----------------------------------------------------------
#  タグ復元
#-----------------------------------------------------------
sub tag {
	local($_) = @_;

	# 変換
	s/&lt;/</g;
	s/&gt;/>/g;
	s/&amp;/&/g;
	s/&quot;/"/g;
	$_;
}

#-----------------------------------------------------------
#  編集画面
#-----------------------------------------------------------
sub edit_data {
	# 修正実行
	if ($in{submit}) { edit_log(); }

	# ログを開く
	my $log;
	open(IN,"$cf{logfile}") or &error("open err: $cf{logfile}");
	my $top = <IN>;
	while (<IN>) {
		chomp;
		my ($no,$re,$x,$sub,$eml,$url,$nam,$dat,$msg,$t,$ho,$pw,$wr,$oya,$sml,$res,$e1,$w1,$h1,$key,$e2,$w2,$h2,$e3,$w3,$h3,$e4,$w4,$h4,$e5,$w5,$h5,$imgtxt1,$imgtxt2,$imgtxt3,$imgtxt4,$imgtxt5) = split(/<>/);

		if ($in{no} == $no) {
			$log = $_;
			last;
		}
	}
	close(IN);

	# 記事分解
	my ($no,$re,$x,$sub,$eml,$url,$nam,$dat,$msg,$t,$ho,$pw,$wr,$oya,$sml,$res,$e1,$w1,$h1,$key,$e2,$w2,$h2,$e3,$w3,$h3,$e4,$w4,$h4,$e5,$w5,$h5,$imgtxt1,$imgtxt2,$imgtxt3,$imgtxt4,$imgtxt5) = split(/<>/, $log);
	$msg =~ s|<br( /)?>|\n|g;

	# 編集フォームを出力
	header("メニューTOP ＞ 記事リスト ＞ 編集画面");
	back_btn('list_data');
	print <<EOM;
<div id="main">
<div id="main-in">
<div class="ttl">■ 記事リスト ＞ 編集画面</div>
<p style="font-size:10.5pt; margin-left:12px">▼変更したい部分のみ修正し送信ボタンを押してください。</p>
<form action="$cf{admin_cgi}" method="post" enctype="multipart/form-data">
<input type="hidden" name="mode" value="edit">
<input type="hidden" name="no" value="$in{no}">
<input type="hidden" name="sid" value="$in{sid}">
<table class="panel2">
<tr>
	<th>投稿者</th>
	<td><input type="text" name="name" value="$nam" size="" class="reg-name"></td>
</tr><tr>
	<th>Ｅメール</th>
	<td><input type="text" name="email" value="$eml" size="" class="reg-name">
		<select name="smail">
EOM

	my @sm = ('表示', '非表示');
	foreach (0,1) {
		if ($sml == $_) {
			print "<option value=\"$_\" selected>$sm[$_]\n";
		} else {
			print "<option value=\"$_\">$sm[$_]\n";
		}
	}

	print <<EOM;
	</select></td>
</tr><tr>
	<th>タイトル</th>
	<td><input type="text" name="sub" value="$sub" size="" class="reg-ttl"></td>
</tr><tr>
	<th>メッセージ</th>
	<td>
		<input type="checkbox" onclick="toggleHtmlEditor(this.checked,'myArea3','full')">エディタ起動<br>
		<textarea name="message" style="width:650px;height:400px;" id="myArea3" class="reg-com" rows="8">$msg</textarea>
	</td>
</tr><tr>
	<th>参照先</th>
	<td><input type="text" name="url" value="$url" size="" class="reg-url"></td>
</tr><tr>
	<th>UPファイル</th>
	<td>
EOM

	if ($e1) {
		print qq|<input type="file" name="upfile1" size="36" />&nbsp;&nbsp;&nbsp;\n|;
		print qq|[<a href="$cf{upldir}/$no-1$e1" target="_blank">閲覧/開く</a>]\n|;
		print qq|<input type="checkbox" name="imgdel01" value="1">削除<br />\n|;
		print qq|<input type="text" name="imgtext1" class="reg-imgtxt" placeholder="タイトル" value="$imgtxt1" size="25"><br /><hr>\n|;
	} else {
		print qq|<input type="file" name="upfile1" size="36" /><br />\n|;
		print qq|<input type="text" name="imgtext1" class="reg-imgtxt" placeholder="タイトル" value="" size="25"><br /><hr>\n|;
	}
	if ($e2) {
		print qq|<input type="file" name="upfile2" size="36" />&nbsp;&nbsp;&nbsp;\n|;
		print qq|[<a href="$cf{upldir}/$no-2$e2" target="_blank">閲覧/開く</a>]\n|;
		print qq|<input type="checkbox" name="imgdel02" value="1">削除<br />\n|;
		print qq|<input type="text" name="imgtext2" class="reg-imgtxt" placeholder="タイトル" value="$imgtxt2" size="25"><br /><hr>\n|;
	} else {
		print qq|<input type="file" name="upfile2" size="36" /><br />\n|;
		print qq|<input type="text" name="imgtext2" class="reg-imgtxt" placeholder="タイトル" value="" size="25"><br /><hr>\n|;
	}
	if ($e3) {
		print qq|<input type="file" name="upfile3" size="36" />&nbsp;&nbsp;&nbsp;\n|;
		print qq|[<a href="$cf{upldir}/$no-3$e3" target="_blank">閲覧/開く</a>]\n|;
		print qq|<input type="checkbox" name="imgdel03" value="1">削除<br />\n|;
		print qq|<input type="text" name="imgtext3" class="reg-imgtxt" placeholder="タイトル" value="$imgtxt3" size="25"><br /><hr>\n|;
	} else {
		print qq|<input type="file" name="upfile3" size="36" /><br />\n|;
		print qq|<input type="text" name="imgtext3" class="reg-imgtxt" placeholder="タイトル" value="" size="25"><br /><hr>\n|;
	}
	if ($e4) {
		print qq|<input type="file" name="upfile4" size="36" />&nbsp;&nbsp;&nbsp;\n|;
		print qq|[<a href="$cf{upldir}/$no-4$e4" target="_blank">閲覧/開く</a>]\n|;
		print qq|<input type="checkbox" name="imgdel04" value="1">削除<br />\n|;
		print qq|<input type="text" name="imgtext4" class="reg-imgtxt" placeholder="タイトル" value="$imgtxt4" size="25"><br /><hr>\n|;
	} else {
		print qq|<input type="file" name="upfile4" size="36" /><br />\n|;
		print qq|<input type="text" name="imgtext4" class="reg-imgtxt" placeholder="タイトル" value="" size="25"><br /><hr>\n|;
	}
	if ($e5) {
		print qq|<input type="file" name="upfile5" size="36" />&nbsp;&nbsp;&nbsp;\n|;
		print qq|[<a href="$cf{upldir}/$no-5$e5" target="_blank">閲覧/開く</a>]\n|;
		print qq|<input type="checkbox" name="imgdel05" value="1">削除<br />\n|;
		print qq|<input type="text" name="imgtext5" class="reg-imgtxt" placeholder="タイトル" value="$imgtxt5" size="25"><br />\n|;
	} else {
		print qq|<input type="file" name="upfile5" size="36" /><br />\n|;
		print qq|<input type="text" name="imgtext5" class="reg-imgtxt" placeholder="タイトル" value="" size="25"><br />\n|;
	}
	print <<EOM;
</td></tr>
</table>
<input type="submit" name="submit" value=" 送信する " />
</form>
</div></div>
</body>
</html>
EOM
	nic_edit();

	footer();
	exit;
}

#-----------------------------------------------------------
#  nicEdit定義
#-----------------------------------------------------------
sub nic_edit {
	print <<'EOM';
<script>
var html_editor = new Array();
var html_editor_loaded = false;
function loadHtmlEditor() {
	if (!html_editor_loaded) {
		var scripts = document.getElementsByTagName('script');
		for (var i=0; i<scripts.length; i++) {
			if (scripts[i].src.search(/nicEdit\.js$/) != -1) return true;
		}
		var header = document.getElementsByTagName('head')[0];
		var loader = document.createElement('script');
		loader.setAttribute('type','text/javascript');
EOM

	# パス指定
	print qq|loader.setAttribute('src','./js/nicEdit_ja/nicEdit.js');\n|;

	print <<'EOM';
		header.appendChild(loader);
		html_editor_loaded = true;
	}
}
function updateHtmlEditor(this_id) {
	if (html_editor[this_id] != null) {
		html_editor[this_id].updateInstance(this_id);
	}
}
function toggleHtmlEditor(open,this_id,panel_type) {
	if (open) {
		if (typeof nicEditor == "undefined") {
			loadHtmlEditor();
			setTimeout(function() { toggleHtmlEditor(open,this_id,panel_type) },500);
		} else {
			if (html_editor[this_id] == null) html_editor[this_id] = new nicEditor({panelType : panel_type}).panelInstance(this_id);
		}
	} else if (html_editor[this_id] != null) {
		html_editor[this_id].removeInstance(this_id);
		html_editor[this_id] = null;
	}
}
</script>
EOM
}

#-----------------------------------------------------------
#  編集実行
#-----------------------------------------------------------
sub edit_log {

		# 画像アップ
		my ($e1n,$w1n,$h1n,$e2n,$w2n,$h2n,$e3n,$w3n,$h3n,$e4n,$w4n,$h4n,$e5n,$w5n,$h5n);
		if ($in{upfile1} || $in{upfile2} || $in{upfile3}|| $in{upfile4}|| $in{upfile5}) {
			($e1n,$w1n,$h1n,$e2n,$w2n,$h2n,$e3n,$w3n,$h3n,$e4n,$w4n,$h4n,$e5n,$w5n,$h5n) = upload($in{no});
		}

	# ログを開く
	my @data;
	open(DAT,"+< $cf{logfile}") or &error("open err: $cf{logfile}");
	eval "flock(DAT, 2);";
	my $top = <DAT>;
	while (<DAT>) {
		chomp;
		my ($no,$re,$x,$sub,$eml,$url,$nam,$dat,$msg,$t,$ho,$pw,$wr,$oya,$sml,$res,$e1,$w1,$h1,$key,$e2,$w2,$h2,$e3,$w3,$h3,$e4,$w4,$h4,$e5,$w5,$h5,$imgtxt1,$imgtxt2,$imgtxt3,$imgtxt4,$imgtxt5) = split(/<>/);

		if ($in{no} == $no) {

			# 画像削除
			if ($in{imgdel01} && $e1) {
				unlink("$cf{upldir}/$no-1$e1") if ($e1);
				unlink("$cf{upldir}/$no-s-1$e1") if ($e1 && -f "$cf{upldir}/$no-s-1$e1");
				$e1 = $w1 = $h1 = '';
			}
			if ($in{imgdel02} && $e2) {
				unlink("$cf{upldir}/$no-2$e2") if ($e2);
				unlink("$cf{upldir}/$no-s-2$e2") if ($e2 && -f "$cf{upldir}/$no-s-2$e2");
				$e2 = $w2 = $h2 = '';
			}
			if ($in{imgdel03} && $e3) {
				unlink("$cf{upldir}/$no-3$e3") if ($e3);
				unlink("$cf{upldir}/$no-s-3$e3") if ($e3 && -f "$cf{upldir}/$no-s-3$e3");
				$e3 = $w3 = $h3 = '';
			}
			if ($in{imgdel04} && $e4) {
				unlink("$cf{upldir}/$no-4$e4") if ($e1);
				unlink("$cf{upldir}/$no-s-4$e4") if ($e1 && -f "$cf{upldir}/$no-s-4$e4");
				$e4 = $w4 = $h4 = '';
			}
			if ($in{imgdel05} && $e5) {
				unlink("$cf{upldir}/$no-5$e5") if ($e1);
				unlink("$cf{upldir}/$no-s-5$e5") if ($e1 && -f "$cf{upldir}/$no-s-5$e5");
				$e5 = $w5 = $h5 = '';
			}

				# 画像差替（拡張子が異なる場合）
				if ($e1n && $e1n ne $e1) {
					unlink("$cf{imgdir}/$no-1$e1");
					unlink("$cf{imgdir}/$no-s-1$e1") if (-f "$cf{imgdir}/$no-s-1$e1");
				}
				if ($e2n && $e2n ne $e2) {
					unlink("$cf{imgdir}/$no-2$e2");
					unlink("$cf{imgdir}/$no-s-2$e2") if (-f "$cf{imgdir}/$no-s-2$e2");
				}
				if ($e3n && $e3n ne $e3) {
					unlink("$cf{imgdir}/$no-3$e3");
					unlink("$cf{imgdir}/$no-s-3$e3") if (-f "$cf{imgdir}/$no-s-3$e3");
				}
				if ($e4n && $e4n ne $e4) {
					unlink("$cf{imgdir}/$no-4$e4");
					unlink("$cf{imgdir}/$no-s-4$e4") if (-f "$cf{imgdir}/$no-s-4$e4");
				}
				if ($e5n && $e5n ne $e5) {
					unlink("$cf{imgdir}/$no-5$e5");
					unlink("$cf{imgdir}/$no-s-5$e5") if (-f "$cf{imgdir}/$no-s-5$e5");
				}

				# 画像差替
				if ($e1n) { $e1 = $e1n; $w1 = $w1n; $h1 = $h1n; }
				if ($e2n) { $e2 = $e2n; $w2 = $w2n; $h2 = $h2n; }
				if ($e3n) { $e3 = $e3n; $w3 = $w3n; $h3 = $h3n; }
				if ($e4n) { $e4 = $e4n; $w4 = $w4n; $h4 = $h4n; }
				if ($e5n) { $e5 = $e5n; $w5 = $w5n; $h5 = $h5n; }

			$_ = "$no<>$re<>$x<>$in{sub}<>$in{email}<>$in{url}<>$in{name}<>$dat<>$in{message}<>$t<>$ho<>$pw<><>$oya<>$in{smail}<>$res<>$e1<>$w1<>$h1<>1<>$e2<>$w2<>$h2<>$e3<>$w3<>$h3<>$e4<>$w4<>$h4<>$e5<>$w5<>$h5<>$in{imgtext1}<>$in{imgtext2}<>$in{imgtext3}<>$in{imgtext4}<>$in{imgtext5}<>";
		}
		push(@data,"$_\n");
	}

	# ログを更新
	unshift(@data,$top);
	seek(DAT, 0, 0);
	print DAT @data;
	truncate(DAT, tell(DAT));
	close(DAT);

	# 完了
	message("修正を完了しました");
}

#-----------------------------------------------------------
#  削除処理
#-----------------------------------------------------------
sub dele_data {
	my %del;
	foreach ( $cgi->param('no') ) {
		$del{$_}++;
	}

	# ログを開く
	my @data;
	open(DAT,"+< $cf{logfile}") or &error("open err: $cf{logfile}");
	eval "flock(DAT, 2);";
	my $top = <DAT>;
	while (<DAT>) {
		my ($no,$re,$x,$sub,$eml,$url,$nam,$dat,$msg,$t,$ho,$pw,$wr,$oya,$sml,$res,$e1,$w1,$h1,$key,$e2,$w2,$h2,$e3,$w3,$h3,$e4,$w4,$h4,$e5,$w5,$h5,$imgtxt1,$imgtxt2,$imgtxt3,$imgtxt4,$imgtxt5) = split(/<>/);

		if (defined($del{$no}) or defined($del{$oya})) {
				if ($e1) {
					unlink("$cf{imgdir}/$no-1$e1");
					unlink("$cf{imgdir}/$no-s1$e1") if (-f "$cf{imgdir}/$no-s1$e1");
				}
				if ($e2) {
					unlink("$cf{imgdir}/$no-2$e2");
					unlink("$cf{imgdir}/$no-s2$e2") if (-f "$cf{imgdir}/$no-s2$e2");
				}
				if ($e3) {
					unlink("$cf{imgdir}/$no-3$e3");
					unlink("$cf{imgdir}/$no-s3$e3") if (-f "$cf{imgdir}/$no-s3$e3");
				}
				if ($e4) {
					unlink("$cf{upldir}/$no-4$e4");
					unlink("$cf{upldir}/$no-s-4$e4") if (-f "$cf{upldir}/$no-s-4$e4");
				}
				if ($e5) {
					unlink("$cf{upldir}/$no-5$e5");
					unlink("$cf{upldir}/$no-s-5$e5") if (-f "$cf{upldir}/$no-s-5$e5");
				}
			next;
		}

		push(@data,$_);
	}

	# ログを更新
	unshift(@data,$top);
	seek(DAT, 0, 0);
	print DAT @data;
	truncate(DAT, tell(DAT));
	close(DAT);

	# 初期画面に戻る
	list_data();
}

#-----------------------------------------------------------
#  スレッドロック開閉
#-----------------------------------------------------------
sub lock_data {
	my %lock;
	foreach ( $cgi->param('no') ) {
		$lock{$_}++;
	}

		# ロック情報をマッチングし更新
		my @data;
		open(DAT,"+< $cf{logfile}") or err("open err: $cf{logfile}");
		eval "flock(DAT, 2);";
		my $top = <DAT>;
		while (<DAT>) {
			my ($no,$re,$x,$sub,$eml,$url,$nam,$dat,$msg,$t,$ho,$pw,$wr,$oya,$sml,$res,$e1,$w1,$h1,$key,$e2,$w2,$h2,$e3,$w3,$h3,$e4,$w4,$h4,$e5,$w5,$h5,$imgtxt1,$imgtxt2,$imgtxt3,$imgtxt4,$imgtxt5) = split(/<>/);

			#if ($no == $in{no}) {
		if (defined($lock{$no}) or defined($lock{$oya})) {
				if ($key == 0) { $key = 1; } else { $key = 0; }
				$_ = "$no<>$re<>$x<>$sub<>$eml<>$url<>$nam<>$dat<>$msg<>$t<>$ho<>$pw<>$wr<>$oya<>$sml<>$res<>$e1<>$w1<>$h1<>$key<>$e2<>$w2<>$h2<>$e3<>$w3<>$h3<>$e4<>$w4<>$h4<>$e5<>$w5<>$h5<>$imgtxt1<>$imgtxt2<>$imgtxt3<>$imgtxt4<>$imgtxt5<>\n";
			}
			push(@data,$_);
		}

		# 更新
		unshift(@data,$top);
		seek(DAT, 0, 0);
		print DAT @data;
		truncate(DAT, tell(DAT));
		close(DAT);

	# 初期画面に戻る
	list_data();
}

#-----------------------------------------------------------
#  解決済ロック
#-----------------------------------------------------------
sub solved_data {
	my %solved;
	foreach ( $cgi->param('no') ) {
		$solved{$_}++;
	}

		# ロック情報をマッチングし更新
		my @data;
		open(DAT,"+< $cf{logfile}") or err("open err: $cf{logfile}");
		eval "flock(DAT, 2);";
		my $top = <DAT>;
		while (<DAT>) {
			my ($no,$re,$x,$sub,$eml,$url,$nam,$dat,$msg,$t,$ho,$pw,$wr,$oya,$sml,$res,$e1,$w1,$h1,$key,$e2,$w2,$h2,$e3,$w3,$h3,$e4,$w4,$h4,$e5,$w5,$h5,$imgtxt1,$imgtxt2,$imgtxt3,$imgtxt4,$imgtxt5) = split(/<>/);

			#if ($no == $in{no}) {
		if (defined($solved{$no}) or defined($solved{$oya})) {
				if ($key == 2) { $key = 1; } else { $key = 2; }
				$_ = "$no<>$re<>$x<>$sub<>$eml<>$url<>$nam<>$dat<>$msg<>$t<>$ho<>$pw<>$wr<>$oya<>$sml<>$res<>$e1<>$w1<>$h1<>$key<>$e2<>$w2<>$h2<>$e3<>$w3<>$h3<>$e4<>$w4<>$h4<>$e5<>$w5<>$h5<>$imgtxt1<>$imgtxt2<>$imgtxt3<>$imgtxt4<>$imgtxt5<>\n";
			}
			push(@data,$_);
		}

		# 更新
		unshift(@data,$top);
		seek(DAT, 0, 0);
		print DAT @data;
		truncate(DAT, tell(DAT));
		close(DAT);

	# 初期画面に戻る
	list_data();
}

#-----------------------------------------------------------
#  添付アップロード
#-----------------------------------------------------------
sub upload {
	my $no = shift;
	
	# サムネイル機能
	require './lib/thumb.pl' if ($cf{thumbnail});

	my @ret;
	foreach my $i (1 .. 5) {

		# mimeタイプ
		my $mime = $cgi->param_mime("upfile$i");

		# 拡張子取得
		my $fname = $cgi->param_filename("upfile$i");
		if ($fname =~ /(\.jpe?g|\.png|\.gif|\.pdf|\.txt|\.doc|\.docx|\.xls|\.xlsx|\.ppt|\.pptx|\.zip|\.mp3|\.mp4)$/i) {
			my $ex = $1;
			$ex =~ tr/A-Z/a-z/;
			if ($ex eq '.jpeg') { $ex = '.jpg'; }

			# 整合性チェック
			my $flg;
			if ($cf{ok_gif}) {
				if ($mime =~ /^image\/gif$/i and $ex eq '.gif') { $flg++; }
			}
			if (!$flg and $cf{ok_jpeg}) {
				if ($mime =~ /^image\/p?jpe?g$/i and $ex eq '.jpg') { $flg++; }
			}
			if (!$flg and $cf{ok_png}) {
				if ($mime =~ /^image\/(x-)?png$/i and $ex eq '.png') { $flg++; }
			}
			if (!$flg and $cf{ok_pdf}) {
				if ($mime =~ /^application\/pdf$/i and $ex eq '.pdf') { $flg++; }
			}
			if (!$flg and $cf{ok_zip}) {
				if ($mime =~ /^application\/(x-)?zip(-compressed)?$/i and $ex eq '.zip') { $flg++; }
			}
			if (!$flg and $cf{ok_text}) {
				if ($mime =~ /^text\/plain$/i and $ex =~ /^\.te?xt$/) { $flg++; }
			}
			if (!$flg and $cf{ok_word}) {
				if ($mime =~ /^application\/(vnd\.)?ms-?word$/i and $ex eq '.doc') { $flg++; }
				elsif ($mime =~ /^application\/vnd\.openxmlformats-officedocument\.wordprocessingml\.document$/i and $ex eq '.docx') { $flg++; }
			}
			if (!$flg and $cf{ok_excel}) {
				if ($mime =~ /^application\/(vnd\.)?ms-?excel$/i and $ex eq '.xls') { $flg++; }
				elsif ($mime =~ /^application\/vnd\.openxmlformats-officedocument\.spreadsheetml\.sheet$/i and $ex eq '.xlsx') { $flg++; }
			}
			if (!$flg and $cf{ok_ppt}) {
				if ($mime =~ /^application\/(vnd\.)?ms-?powerpoint$/i and $ex eq '.ppt') { $flg++; }
				elsif ($mime =~ /^application\/vnd\.openxmlformats-officedocument\.presentationml\.presentation$/i and $ex eq '.pptx') { $flg++; }
			}
			if (!$flg and $cf{ok_mp3}) {
				if ($mime =~ /^audio\/mpeg$/i and $ex eq '.mp3') { $flg++; }
				elsif ($mime =~ /^audio\/mp3/i and $ex eq '.mp3') { $flg++; }
				elsif ($mime =~ /^audio\/mpg/i and $ex eq '.mp3') { $flg++; }
			}
			if (!$flg and $cf{ok_mp4}) {
				if ($mime =~ /^video\/mpeg$/i and $ex eq '.mp4') { $flg++; }
				elsif ($mime =~ /^video\/mp4/i and $ex eq '.mp4') { $flg++; }
				elsif ($mime =~ /^video\/mpg/i and $ex eq '.mp4') { $flg++; }
			}
			if (!$flg) { error('このファイルは取り扱いできません'); }

		# 添付ファイル定義
		my $upfile = "$cf{upldir}/$no-$i$ex";

		# アップロード書き込み
		open(UP,"+> $upfile") or error("up err: $upfile");
		binmode(UP);
		print UP $in{"upfile$i"};
		close(UP);

		# パーミッション付与
		chmod(0666,$upfile);

		# 画像の場合サイズ取得
		my ($flg,$w,$h);
		if ($ex eq ".jpg") { ($w,$h) = j_size($upfile); $flg++; }
		elsif ($ex eq ".gif") { ($w,$h) = g_size($upfile); $flg++; }
		elsif ($ex eq ".png") { ($w,$h) = p_size($upfile); $flg++; }

		# サムネイル作成
		if ($flg && $cf{thumbnail}) {
			($w,$h) = resize($w,$h);
			my $thumb = "$cf{upldir}/$no-s-$i$ex";
			make_thumb($upfile,$thumb,$w,$h);
		}

		# 拡張子, 横幅, 縦幅 の順
			push(@ret,($ex,$w,$h));
		} else {
			push(@ret,('','',''));
		}
	}
	# 結果を返す
	return @ret;
}

#-----------------------------------------------------------
#  JPEGサイズ認識
#-----------------------------------------------------------
sub j_size {
	my $jpg = shift;

	my ($h, $w, $t);
	open(IMG,"$jpg");
	binmode(IMG);
	read(IMG, $t, 2);
	while (1) {
		read(IMG, $t, 4);
		my ($m, $c, $l) = unpack("a a n", $t);

		if ($m ne "\xFF") {
			$w = $h = 0;
			last;
		} elsif ((ord($c) >= 0xC0) && (ord($c) <= 0xC3)) {
			read(IMG, $t, 5);
			($h, $w) = unpack("xnn", $t);
			last;
		} else {
			read(IMG, $t, ($l - 2));
		}
	}
	close(IMG);

	return ($w, $h);
}

#-----------------------------------------------------------
#  GIFサイズ認識
#-----------------------------------------------------------
sub g_size {
	my $gif = shift;

	my $data;
	open(IMG,"$gif");
	binmode(IMG);
	sysread(IMG, $data, 10);
	close(IMG);

	if ($data =~ /^GIF/) { $data = substr($data, -4); }
	my $w = unpack("v", substr($data, 0, 2));
	my $h = unpack("v", substr($data, 2, 2));

	return ($w, $h);
}

#-----------------------------------------------------------
#  PNGサイズ認識
#-----------------------------------------------------------
sub p_size {
	my $png = shift;

	my $data;
	open(IMG,"$png");
	binmode(IMG);
	read(IMG, $data, 24);
	close(IMG);

	my $w = unpack("N", substr($data, 16, 20));
	my $h = unpack("N", substr($data, 20, 24));

	return ($w, $h);
}

#-----------------------------------------------------------
#  HTMLヘッダー
#-----------------------------------------------------------
sub header {
	my $ttl = shift;

	print <<EOM;
Content-type: text/html; charset=utf-8

<!DOCTYPE html>
<html lang="ja">
<head>
<meta charset="utf-8">
<meta http-equiv="content-script-type" content="text/javascript" />
<meta http-equiv="content-style-type" content="text/css" />
<meta name="viewport" content="width=device-width,initial-scale=1.0,minimum-scale=1.0,maximum-scale=1.0,user-scalable=no">
<script type="text/javascript" src="./cmn/footerFixed_modified.js"></script>
<link href="cmn/admin.css" rel="stylesheet" type="text/css" />
<title>$ttl</title>
</head>
<body>
<div id="head">
	<img src="$cf{cmnurl}/star.png" alt="star" class="icon">
	:: Web Forum v8.0 管理画面 ::
</div>
EOM
}

#-----------------------------------------------------------
#  フッター
#-----------------------------------------------------------
sub footer {
	my $foot = shift;

	# 著作権表記（削除・改変禁止）
	my $copy = <<EOM;
<div id="footer">
	- <a href="http://www.kent-web.com/" target="_top">$cf{version}</a> -<br>
	++ <a href="http://www.transformsite.com/" target="_top">Edited by TRANSFORM</a> ++
</div>
EOM

	if ($foot =~ /(.+)(<\/body[^>]*>.*)/si) {
		print "$1$copy$2\n";
	} else {
		print "$foot$copy\n";
		print "</body></html>\n";
	}
	exit;
}

#-----------------------------------------------------------
#  戻りボタン
#-----------------------------------------------------------
sub back_btn {
	my ($mode) = @_;

	print <<EOM;
<div align="right">
<form action="$cf{admin_cgi}" method="post">
<input type="hidden" name="sid" value="$in{sid}">
@{[ $mode ? qq|<input type="submit" name="$mode" value="&lt; 前画面" >| : "" ]}
<input type="submit" value="&lt; メニュー" />
</form>
</div>
EOM
}

#-----------------------------------------------------------
#  エラー
#-----------------------------------------------------------
sub err {
	my $msg = shift;

	header("ERROR!");
	print <<EOM;
<div align="center">
<hr width="350">
<h3>ERROR!</h3>
<p style="color:#dd0000">$msg</p>
<hr width="350">
<form>
<input type="button" value="前画面に戻る" onclick="history.back()" />
</form>
</div>
</body>
</html>
EOM
	exit;
}

#-----------------------------------------------------------
#  メッセージ表示
#-----------------------------------------------------------
sub message {
	my ($msg,$btn) = @_;

	header("処理完了");
	print <<EOM;
<div id="main">
<div id="main-in">
<b class="ttl">■処理完了</b>
<hr color="#00f078">
<p>$msg</p>
<form action="$cf{admin_cgi}" method="post">
<input type="hidden" name="sid" value="$in{sid}">
<input type="hidden" name="list_data" value="1">
<input type="submit" value="メニューに戻る" />
</form>
</div></div>
</body>
</html>
EOM
	exit;
}

