#!/usr/bin/perl

#┌─────────────────────────────────
#│ Web Forum : post.cgi - 2019/12/31
#│ Copyright (c) KentWeb
#│ http://www.kent-web.com/
#└─────────────────────────────────
# REBUILD(改造)
#┌─────────────────────────────────
#│  Web Forum v8.0P Multi : post.cgi - 2022/11/25
#│  Edited by TRANSFORM Since 2012
#│  http://www.transformsite.com/
#└─────────────────────────────────

# モジュール宣言
use strict;
use CGI::Carp qw(fatalsToBrowser);
use lib "./lib";
use CGI::Minimal;

# 設定ファイル認識
require "./init.cgi";
my %cf = set_init();

# データ受理
CGI::Minimal::max_read_size($cf{maxdata});
my $cgi = CGI::Minimal->new;
error('容量オーバー') if ($cgi->truncated);
my %in = parse_form($cgi);

# アクセス制限
passwd(%in) if ($cf{enter_pwd} ne '');

# 処理分岐
if ($in{mode} eq "post") { post_data(); }
elsif ($in{mode} eq "user_edit") { user_edit(); }
elsif ($in{mode} eq "user_dele") { user_dele(); }
elsif ($in{mode} eq "user_lock") { user_lock(); }
error('不明な処理です');

#-----------------------------------------------------------
#  書込処理
#-----------------------------------------------------------
sub post_data {

	if ($in{addform}){ # 追加画像数の変更操作・投稿・返信フォームでの操作

	my ($alldata,$data,$key,$value);
	if ($ENV{'REQUEST_METHOD'} eq 'POST') {
	  read(STDIN, $alldata, $ENV{'CONTENT_LENGTH'});
	} else {
	  $alldata = $ENV{'QUERY_STRING'};
	}
	foreach $data (split(/&/, $alldata)) {
	  ($key, $value) = split(/=/, $data);

	  $value =~ s/\+/ /g;
	  $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack('C', hex($1))/eg;
	  $value =~ s/\t//g;

	  $in{$key} = $value;
	}

		# クッキーを発行
		ref_set_cookie($in{name},$in{email},$in{url},$in{smail},$in{formnum});

		# 投稿フォーム画面に戻る
		if ($ENV{PERLXS} eq "PerlIS") {
			print "HTTP/1.0 302 Temporary Redirection\r\n";
			print "Content-type: text/html\n";
		}
		print "Location: $cf{checge_url}\n\n";
	}

	if ($in{res_addform}){ # 追加画像数の変更操作・投稿・返信フォームでの操作

	my ($alldata,$data,$key,$value);
	if ($ENV{'REQUEST_METHOD'} eq 'POST') {
	  read(STDIN, $alldata, $ENV{'CONTENT_LENGTH'});
	} else {
	  $alldata = $ENV{'QUERY_STRING'};
	}
	foreach $data (split(/&/, $alldata)) {
	  ($key, $value) = split(/=/, $data);

	  $value =~ s/\+/ /g;
	  $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack('C', hex($1))/eg;
	  $value =~ s/\t//g;

	  $in{$key} = $value;
	}

		# クッキーを発行
		refres_set_cookie($in{name},$in{email},$in{url},$in{smail},$in{formnum});

		# 編集フォーム画面に戻る
		if ($ENV{PERLXS} eq "PerlIS") {
			print "HTTP/1.0 302 Temporary Redirection\r\n";
			print "Content-type: text/html\n";
		}
		print "Location: $cf{bbs_cgi}?mode=read&no=$in{no}&reno=no&oya=$in{no}&page=0#$in{no}\n\n";
	}

	# POSTメソッド以外は不受理
	if ($ENV{REQUEST_METHOD} ne 'POST') {
		error("不正なリクエストです");
	}

	# 入力チェック
	check_input();

	# 投稿キーチェック
	if ($cf{use_captcha} > 0) {
		require $cf{captcha_pl};
		if ($in{captcha} !~ /^\d{$cf{cap_len}}$/) {
			&error("投稿キーが入力不備です。<br>投稿フォームに戻って再読込み後、再入力してください");
		}

		# 投稿キーチェック
		# -1 : キー不一致
		#  0 : 制限時間オーバー
		#  1 : キー一致
		my $chk = cap::check($in{captcha},$in{str_crypt},$cf{captcha_key},$cf{cap_time},$cf{cap_len});
		if ($chk == 0) {
			error("投稿キーが制限時間を超過しました。<br>投稿フォームに戻って再読込み後、指定の数字を再入力してください");
		} elsif ($chk == -1) {
			error("投稿キーが不正です。<br>投稿フォームに戻って再読込み後、再入力してください");
		}
	}

	# ホストチェック
	my ($host,$addr) = check_host();

	# ログファイル読み込み
	open(DAT,"+< $cf{logfile}") or &error("open err: $cf{logfile}");
	eval "flock(DAT, 2);";
	my @lines = <DAT>;

	# カウントファイルをアップ
	my $top = shift(@lines);
	my ($count,$ip,$tim) = split(/<>/, $top);
	$count = $count % 9999 ? ++$count : 1;

	# 時間を取得
	my $times = time;
	my $date = get_time($times, "log");

	# 二重投稿の禁止
	my $flg;
	if ($cf{regCtl} == 1) {
		if ($addr eq $ip && $times - $tim < $cf{wait}) { $flg++; }
	} elsif ($cf{regCtl} == 2) {
		if ($times - $tim < $cf{wait}) { $flg++; }
	}
	if ($flg) {
		close(DAT);
		error("現在投稿制限中です。もうしばらくたってから投稿をお願いします");
	}

	my $flg;
	foreach (@lines) {
		my ($name,$msg) = (split(/<>/))[6,8];
		if ($in{name} eq $name && $in{message} eq $msg) { $flg++; last; }
	}
	if ($flg) { error("二重投稿は禁止です"); }

	# 画像アップ
	my ($e1,$w1,$h1,$e2,$w2,$h2,$e3,$w3,$h3,$e4,$w4,$h4,$e5,$w5,$h5)
			= $in{upfile1} || $in{upfile2} || $in{upfile3} || $in{upfile4} || $in{upfile5} ? upload($count) : ();

	# クッキー格納
	set_cookie($in{name},$in{email},$in{url},$in{smail});

	# パスワード暗号化
	my $ango = &encrypt($in{pwd}) if ($in{pwd} ne "");

	## --- 親記事の場合
	my (@new,@tmp);
	if ($in{no} eq 'new') {
		unshift (@lines,"$count<>no<>0<>$in{sub}<>$in{email}<>$in{url}<>$in{name}<>$date<>$in{message}<>$times<>$host<>$ango<>$in{wrap}<>$count<>$in{smail}<>0<>$e1<>$w1<>$h1<>1<>$e2<>$w2<>$h2<>$e3<>$w3<>$h3<>$e4<>$w4<>$h4<>$e5<>$w5<>$h5<>$in{imgtext1}<>$in{imgtext2}<>$in{imgtext3}<>$in{imgtext4}<>$in{imgtext5}<>\n");
		@new = @lines;

	## --- レス記事の場合
	} else {

		# ツリーソート「あり」
	 	if ($cf{top_sort}) {

			my $lx2;
			my $flg;
			foreach (@lines) {
				chomp;
				my ($no,$reno,$lx,$t,$e,$u,$n,$d,$m,$tm,$h,$a,$w,$oya,$smail,$res,$e1n,$w1n,$h1n,$key,$e2n,$w2n,$h2n,$e3n,$w3n,$h3n,$e4n,$w4n,$h4n,$e5n,$w5n,$h5n,$imgtn1,$imgtn2,$imgtn3,$imgtn4,$imgtn5) = split(/<>/);

				if ($cf{bot_res} && $flg == 1 && $lx2 > $lx && $oya == $in{oya}) {
					$flg = 2;
					push(@new,"$count<>$in{no}<>$lx2<>$in{sub}<>$in{email}<>$in{url}<>$in{name}<>$date<>$in{message}<>$times<>$host<>$ango<>$in{wrap}<>$in{oya}<>$in{smail}<>0<>$e1<>$w1<>$h1<>1<>$e2<>$w2<>$h2<>$e3<>$w3<>$h3<>$e4<>$w4<>$h4<>$e5<>$w5<>$h5<>$in{imgtext1}<>$in{imgtext2}<>$in{imgtext3}<>$in{imgtext4}<>$in{imgtext5}<>\n");
				}

				# 同一ツリーの記事を @new に配列分割（直レス）
				if ($no == $in{no}) {
					$res++;
					push(@new,"$no<>$reno<>$lx<>$t<>$e<>$u<>$n<>$d<>$m<>$tm<>$h<>$a<>$w<>$oya<>$smail<>$res<>$e1n<>$w1n<>$h1n<>1<>$e2n<>$w2n<>$h2n<>$e3n<>$w3n<>$h3n<>$e4n<>$w4n<>$h4n<>$e5n<>$w5n<>$h5n<>$imgtn1<>$imgtn2<>$imgtn3<>$imgtn4<>$imgtn5<>\n");

				# 同一ツリーの記事を @new に配列分割
				} elsif ($in{oya} == $oya) {
					push(@new,"$_\n");

				# 別ツリーの記事を @tmp に配列分割
				} else {
					push(@tmp,"$_\n");
				}

				if ($no == $in{no}) {
					$flg = 1;
					$lx2 = $lx + 1;
					if (!$cf{bot_res}) {
						push(@new,"$count<>$in{no}<>$lx2<>$in{sub}<>$in{email}<>$in{url}<>$in{name}<>$date<>$in{message}<>$times<>$host<>$ango<>$in{wrap}<>$in{oya}<>$in{smail}<>0<>$e1<>$w1<>$h1<>1<>$e2<>$w2<>$h2<>$e3<>$w3<>$h3<>$e4<>$w4<>$h4<>$e5<>$w5<>$h5<>$in{imgtext1}<>$in{imgtext2}<>$in{imgtext3}<>$in{imgtext4}<>$in{imgtext5}<>\n");
					}
				}
			}
			if ($flg == 0) {
				close(DAT);
				error("親記事が見当たりません");
			}
			if ($cf{bot_res} && $flg != 2) {
				push(@new,"$count<>$in{no}<>$lx2<>$in{sub}<>$in{email}<>$in{url}<>$in{name}<>$date<>$in{message}<>$times<>$host<>$ango<>$in{wrap}<>$in{oya}<>$in{smail}<>0<>$e1<>$w1<>$h1<>1<>$e2<>$w2<>$h2<>$e3<>$w3<>$h3<>$e4<>$w4<>$h4<>$e5<>$w5<>$h5<>$in{imgtext1}<>$in{imgtext2}<>$in{imgtext3}<>$in{imgtext4}<>$in{imgtext5}<>\n");
			}
			# 配列最終結合
			push(@new,@tmp);

		# ツリーソート「なし」
		} else {

			my $lx2;
			my $flg = 0;
			foreach (@lines) {
				chomp;
				my ($no,$reno,$lx,$t,$e,$u,$n,$d,$m,$tm,$h,$a,$w,$oya,$smail,$res,$e1n,$w1n,$h1n,$key,$e2n,$w2n,$h2n,$e3n,$w3n,$h3n,$e4n,$w4n,$h4n,$e5n,$w5n,$h5n,$imgtn1,$imgtn2,$imgtn3,$imgtn4,$imgtn5) = split(/<>/);

				if ($cf{bot_res} && $flg == 1 && $lx2 > $lx && ($reno ne $in{no} || $oya != $in{oya})) {
					$flg = 2;
					push(@new,"$count<>$in{no}<>$lx2<>$in{sub}<>$in{email}<>$in{url}<>$in{name}<>$date<>$in{message}<>$times<>$host<>$ango<>$in{wrap}<>$in{oya}<>$in{smail}<>0<>$e1<>$w1<>$h1<>1<>$e2<>$w2<>$h2<>$e3<>$w3<>$h3<>$e4<>$w4<>$h4<>$e5<>$w5<>$h5<>$in{imgtext1}<>$in{imgtext2}<>$in{imgtext3}<>$in{imgtext4}<>$in{imgtext5}<>\n");
				}

				# 直親記事
				if ($no == $in{no}) {
					$res++;
					push(@new,"$no<>$reno<>$lx<>$t<>$e<>$u<>$n<>$d<>$m<>$tm<>$h<>$a<>$w<>$oya<>$smail<>$res<>$e1n<>$w1n<>$h1n<>1<>$e2n<>$w2n<>$h2n<>$e3n<>$w3n<>$h3n<>$e4n<>$w4n<>$h4n<>$e5n<>$w5n<>$h5n<>$imgtn1<>$imgtn2<>$imgtn3<>$imgtn4<>$imgtn5<>\n");

				} else {
					push(@new,"$_\n");
				}

				if ($no == $in{no}) {
					$flg = 1;
       				$lx2 = $lx + 1;
					if (!$cf{bot_res}) {
       					push (@new,"$count<>$no<>$lx2<>$in{sub}<>$in{email}<>$in{url}<>$in{name}<>$date<>$in{message}<>$times<>$host<>$ango<>$in{wrap}<>$in{oya}<>$in{smail}<>0<>$e1<>$w1<>$h1<>1<>$e2<>$w2<>$h2<>$e3<>$w3<>$h3<>$e4<>$w4<>$h4<>$e5<>$w5<>$h5<>$in{imgtext1}<>$in{imgtext2}<>$in{imgtext3}<>$in{imgtext4}<>$in{imgtext5}<>\n");
					}
				}
			}
			if ($flg == 0) {
				close(DAT);
				error("親記事が見当たりません");
			}
			if ($cf{bot_res} && $flg != 2) {
				push(@new,"$count<>$in{no}<>$lx2<>$in{sub}<>$in{email}<>$in{url}<>$in{name}<>$date<>$in{message}<>$times<>$host<>$ango<>$in{wrap}<>$in{oya}<>$in{smail}<>0<>$e1<>$w1<>$h1<>1<>$e2<>$w2<>$h2<>$e3<>$w3<>$h3<>$e4<>$w4<>$h4<>$e5<>$w5<>$h5<>$in{imgtext1}<>$in{imgtext2}<>$in{imgtext3}<>$in{imgtext4}<>$in{imgtext5}<>\n");
			}
    	}
	}

	# 最大記事数処理
	my @past;
	if (@new > $cf{maxlog}) {

		foreach (0 .. $#new) {

			# 最終尾ファイルを配列から抜き出し過去ログ配列へ
			my $log = pop(@new);
			unshift(@past,$log) if ($cf{pastkey});

			# 上位記事及び拡張子情報
			my ($no,$reno,$e1,$e2,$e3,$e4,$e5) = (split(/<>/, $log))[0,1,16,20,23,26,29];

			# 画像削除
			if ($e1) {
				unlink("$cf{upldir}/$no-1$e1");
				unlink("$cf{upldir}/$no-s-1$e1") if (-f "$cf{upldir}/$no-s-1$e1");
			}
			if ($e2) {
				unlink("$cf{upldir}/$no-2$e2");
				unlink("$cf{upldir}/$no-s-2$e2") if (-f "$cf{upldir}/$no-s-2$e2");
			}
			if ($e3) {
				unlink("$cf{upldir}/$no-3$e3");
				unlink("$cf{upldir}/$no-s-3$e3") if (-f "$cf{upldir}/$no-s-3$e3");
			}
			if ($e4) {
				unlink("$cf{upldir}/$no-4$e4");
				unlink("$cf{upldir}/$no-s-4$e4") if (-f "$cf{upldir}/$no-s-4$e4");
			}
			if ($e5) {
				unlink("$cf{upldir}/$no-5$e5");
				unlink("$cf{upldir}/$no-s-5$e5") if (-f "$cf{upldir}/$no-s-5$e5");
			}

			# ツリー単位か
			if (@new <= $cf{maxlog} && $reno eq 'no') {
				last;
			}
		}
	}

	# ログ更新
	unshift(@new,"$count<>$addr<>$times<>\n");
	seek(DAT, 0, 0);
	print DAT @new;
	truncate(DAT, tell(DAT));
	close(DAT);

	# 過去ログ処理
	if (@past > 0) { make_pastlog(@past); }

	# メール通知
	if ($cf{mailing}) { sendmail($count,$host); }

	# 投稿完了
	after_msg($count,$date,$e1,$w1,$h1,$e2,$w2,$h2,$e3,$w3,$h3,$e4,$w4,$h4,$e5,$w5,$h5);
}

#-----------------------------------------------------------
#  投稿後メッセージ
#-----------------------------------------------------------
sub after_msg {
	my ($num,$date,$e1,$w1,$h1,$e2,$w2,$h2,$e3,$w3,$h3,$e4,$w4,$h4,$e5,$w5,$h5) = @_;

	# 引用色
	if ($cf{ref_col}) {
		$in{message} =~ s/([\>]|^)(&gt;[^<]*)/$1<font color="$cf{ref_col}">$2<\/font>/g;
	}

	# 画像付加
	$in{message} = put_image1($num,$in{sub},$in{name},$in{message},$e1,$w1,$h1,$in{imgtext1}) if ($e1);
	$in{message} = put_image2($num,$in{sub},$in{name},$in{message},$e2,$w2,$h2,$in{imgtext2}) if ($e2);
	$in{message} = put_image3($num,$in{sub},$in{name},$in{message},$e3,$w3,$h3,$in{imgtext3}) if ($e3);
	$in{message} = put_image4($num,$in{sub},$in{name},$in{message},$e4,$w4,$h4,$in{imgtext4}) if ($e4);
	$in{message} = put_image5($num,$in{sub},$in{name},$in{message},$e5,$w5,$h5,$in{imgtext5}) if ($e5);

	if ($in{email} && $in{smail} == 1) { $in{email} = '非表示'; }

	open(IN,"$cf{tmpldir}/finish.html") or &error("open err: finish.html");
	my $tmpl = join('', <IN>);
	close(IN);

	$tmpl =~ s/!bbs_cgi!/$cf{bbs_cgi}/g;
	$tmpl =~ s/!post_cgi!/$cf{post_cgi}/g;
	$tmpl =~ s/!bbs_title!/$cf{bbs_title}/g;
	$tmpl =~ s|!bbs_css!|$cf{cmnurl}/bbs.css|g;
	$tmpl =~ s|!bbs_js!|$cf{cmnurl}/bbs.js|g;
	$tmpl =~ s/!sub!/$in{sub}/g;
	$tmpl =~ s/!num!/$num/g;
	$tmpl =~ s/!date!/$date/g;
	$tmpl =~ s/!name!/$in{name}/g;
	$tmpl =~ s/!email!/$in{email}/g;
	$tmpl =~ s/!url!/$in{url}/g;

	$in{message} = tag($in{message});
	$in{message} =~ s/\t/<br>/g;
	$tmpl =~ s/!msg!/$in{message}/g;

	print "Content-type: text/html; charset=utf-8\n\n";
	print $tmpl;

	# フッタ
	footer();

	exit;
}

#-----------------------------------------------------------
#  タグ復元
#-----------------------------------------------------------
sub tag {
	local($_) = @_;

	# 変換
	s/&lt;/</g;
	s/&gt;/>/g;
	s/&amp;/&/g;
	s/&quot;/"/g;
	$_;
}

#-----------------------------------------------------------
#  ユーザ記事修正
#-----------------------------------------------------------
sub user_edit {
	# POSTメソッド以外は不受理
	if ($ENV{REQUEST_METHOD} ne 'POST') {
		error("不正なリクエストです");
	}

	# フォーム内容チェック
	$in{num} =~ s/\D//g;
	if ($in{num} eq '' || $in{pwd} eq '') {
		error("記事NOまたはパスワードの記入モレがあります");
	}
	if ($in{job} eq "edit") {
		# 入力チェック
		check_input();
	}

	# 画像アップ
	my ($e1n,$w1n,$h1n,$e2n,$w2n,$h2n,$e3n,$w3n,$h3n,$e4n,$w4n,$h4n,$e5n,$w5n,$h5n);
	if ($in{upfile1} || $in{upfile2} || $in{upfile3}|| $in{upfile4}|| $in{upfile5}) {
		($e1n,$w1n,$h1n,$e2n,$w2n,$h2n,$e3n,$w3n,$h3n,$e4n,$w4n,$h4n,$e5n,$w5n,$h5n) = upload($in{num});
	}

	my ($flg,$data,$ext,$w,$h,@new);
	open(DAT,"+< $cf{logfile}") or &error("open err: $cf{logfile}");
	eval "flock(DAT, 2);";
	my $top = <DAT>;
	while (<DAT>) {
		chomp;
		my ($no,$re,$lx,$sub,$eml,$url,$nam,$dat,$msg,$lt,$ho,$pw,$wrp,$oya,$sml,$res,$e1,$w1,$h1,$key,$e2,$w2,$h2,$e3,$w3,$h3,$e4,$w4,$h4,$e5,$w5,$h5,$imgtxt1,$imgtxt2,$imgtxt3,$imgtxt4,$imgtxt5) = split(/<>/);

		if ($in{num} == $no) {

			# 暗証キーなし
			if ($pw eq '') { last; }

			# 暗証キー不一致
			elsif (&decrypt($in{pwd},$pw) != 1) { last; }

			$data = $_;
			$flg = 1;

			if ($in{job} ne "edit") {
				last;

			} else {

			# 画像削除のとき
				if ($in{del1}) {
					unlink("$cf{upldir}/$no-1$e1");
					unlink("$cf{upldir}/$no-s-1$e1") if (-f "$cf{upldir}/$no-s-1$e1");
					$e1 = $w1 = $h1 = "";
				}
				if ($in{del2}) {
					unlink("$cf{upldir}/$no-2$e2");
					unlink("$cf{upldir}/$no-s-2$e2") if (-f "$cf{upldir}/$no-s-2$e2");
					$e2 = $w2 = $h2 = "";
				}
				if ($in{del3}) {
					unlink("$cf{upldir}/$no-3$e3");
					unlink("$cf{upldir}/$no-s-3$e3") if (-f "$cf{upldir}/$no-s-3$e3");
					$e3 = $w3 = $h3 = "";
				}
				if ($in{del4}) {
					unlink("$cf{upldir}/$no-4$e4");
					unlink("$cf{upldir}/$no-s-4$e4") if (-f "$cf{upldir}/$no-s-4$e4");
					$e4 = $w4 = $h4 = "";
				}
				if ($in{del5}) {
					unlink("$cf{upldir}/$no-5$e5");
					unlink("$cf{upldir}/$no-s-5$e5") if (-f "$cf{upldir}/$no-s-5$e5");
					$e5 = $w5 = $h5 = "";
				}

				# 画像差替（拡張子が異なる場合）
				if ($e1n && $e1n ne $e1) {
					unlink("$cf{upldir}/$no-1$e1");
					unlink("$cf{upldir}/$no-s-1$e1") if (-f "$cf{upldir}/$no-s-1$e1");
				}
				if ($e2n && $e2n ne $e2) {
					unlink("$cf{upldir}/$no-2$e2");
					unlink("$cf{upldir}/$no-s-2$e2") if (-f "$cf{upldir}/$no-s-2$e2");
				}
				if ($e3n && $e3n ne $e3) {
					unlink("$cf{upldir}/$no-3$e3");
					unlink("$cf{upldir}/$no-s-3$e3") if (-f "$cf{upldir}/$no-s-3$e3");
				}
				if ($e4n && $e4n ne $e4) {
					unlink("$cf{upldir}/$no-4$e4");
					unlink("$cf{upldir}/$no-s-4$e4") if (-f "$cf{upldir}/$no-s-4$e4");
				}
				if ($e5n && $e5n ne $e5) {
					unlink("$cf{upldir}/$no-5$e5");
					unlink("$cf{upldir}/$no-s-5$e5") if (-f "$cf{upldir}/$no-s-5$e5");
				}


				# 画像差替
				if ($e1n) { $e1 = $e1n; $w1 = $w1n; $h1 = $h1n; }
				if ($e2n) { $e2 = $e2n; $w2 = $w2n; $h2 = $h2n; }
				if ($e3n) { $e3 = $e3n; $w3 = $w3n; $h3 = $h3n; }
				if ($e4n) { $e4 = $e4n; $w4 = $w4n; $h4 = $h4n; }
				if ($e5n) { $e5 = $e5n; $w5 = $w5n; $h5 = $h5n; }

				# 編集データ
				$_ = "$no<>$re<>$lx<>$in{sub}<>$in{email}<>$in{url}<>$in{name}<>$dat<>$in{message}<>$lt<>$ho<>$pw<>$in{wrap}<>$oya<>$in{smail}<>$res<>$e1<>$w1<>$h1<>1<>$e2<>$w2<>$h2<>$e3<>$w3<>$h3<>$e4<>$w4<>$h4<>$e5<>$w5<>$h5<>$in{imgtext1}<>$in{imgtext2}<>$in{imgtext3}<>$in{imgtext4}<>$in{imgtext5}<>";
			}
		}
		if ($in{job} eq "edit") { push(@new,"$_\n"); }
	}

	# 暗証キー判定
	if ($flg != 1) {
		close(DAT);
		error('暗証キーが未設定か又は間違っています');
	}

	# 修正実行時
	if ($in{job} eq "edit") {
		unshift(@new,$top);
		seek(DAT, 0, 0);
		print DAT @new;
		truncate(DAT, tell(DAT));
		close(DAT);

		message("記事の修正を完了しました。");

	# 修正フォーム
	} else {
		edit_form($data);
	}
}

#-----------------------------------------------------------
#  ユーザ記事削除
#-----------------------------------------------------------
sub user_dele {
	# POSTメソッド以外は不受理
	if ($ENV{REQUEST_METHOD} ne 'POST') {
		error("不正なリクエストです");
	}

	# フォーム内容のチェック
	$in{num} =~ s/\D//g;
	if ($in{num} eq '' || $in{pwd} eq '') {
		error("記事NOまたはパスワードの記入モレがあります");
	}

	# ログを読み込む
	my ($flg,$match,@new,@del);
	open(DAT,"+< $cf{logfile}") or &error("open err: $cf{logfile}");
	eval "flock(DAT, 2);";
	my $top = <DAT>;
	while (<DAT>) {
		chomp;
		my ($no,$re,$lx,$sub,$eml,$url,$nam,$dat,$msg,$tim,$ho,$pw,$wr,$oya,$sml,$res,$e1,$w1,$h1,$key,$e2,$w2,$h2,$e3,$w3,$h3,$e4,$w4,$h4,$e5,$w5,$h5,$imgtxt1,$imgtxt2,$imgtxt3,$imgtxt4,$imgtxt5) = split(/<>/);

		if ($in{num} == $no) {

			# パス未設定であれば終了
			if ($pw eq "") { last; }

			# 照合
			if (&decrypt($in{pwd},$pw) == 1) {
				$flg = 1;
				if ($e1) {
					unlink("$cf{upldir}/$no-1$e1");
					unlink("$cf{upldir}/$no-s-1$e1") if (-f "$cf{upldir}/$no-s-1$e1");
				}
				if ($e2) {
					unlink("$cf{upldir}/$no-2$e2");
					unlink("$cf{upldir}/$no-s-2$e2") if (-f "$cf{upldir}/$no-s-2$e2");
				}
				if ($e3) {
					unlink("$cf{upldir}/$no-3$e3");
					unlink("$cf{upldir}/$no-s-3$e3") if (-f "$cf{upldir}/$no-s-3$e3");
				}
				if ($e4) {
					unlink("$cf{upldir}/$no-4$e4");
					unlink("$cf{upldir}/$no-s-4$e4") if (-f "$cf{upldir}/$no-s-4$e4");
				}
				if ($e5) {
					unlink("$cf{upldir}/$no-5$e5");
					unlink("$cf{upldir}/$no-s-5$e5") if (-f "$cf{upldir}/$no-s-5$e5");
				}
			} else {
				last;
			}

			if ($res == 0) { next; }
			$_ = "$no<>$re<>$lx<><s>投稿者削除</s><><><>(削除)<>$dat<>(投稿者により削除されました)<>$tim<>$ho<>DEL<>$wr<>$oya<>$sml<>$res<>$e1<>$w1<>$h1<>$key<>$e2<>$w2<>$h2<>$e3<>$w3<>$h3<>$e4<>$w4<>$h4<>$e5<>$w5<>$h5<>$imgtxt1<>$imgtxt2<>$imgtxt3<>$imgtxt4<>$imgtxt5<>";

		} elsif ($no == $in{keyno}) {
			if ($res > 0) { $res--; }
			$_ = "$no<>$re<>$lx<>$sub<>$eml<>$url<>$nam<>$dat<>$msg<>$tim<>$ho<>$pw<>$wr<>$oya<>$sml<>$res<>$e1<>$w1<>$h1<>$key<>$e2<>$w2<>$h2<>$e3<>$w3<>$h3<>$e4<>$w4<>$h4<>$e5<>$w5<>$h5<>$imgtxt1<>$imgtxt2<>$imgtxt3<>$imgtxt4<>$imgtxt5<>";
		}
		push(@new,"$_\n");
	}

	# エラー
	if (!$flg) {
		close(DAT);
		error("暗証キーが未設定か又は認証できません");
	}

	# ログを更新
	unshift(@new,$top);
	seek(DAT, 0, 0);
	print DAT @new;
	truncate(DAT, tell(DAT));
	close(DAT);

	# 完了画面
	message("記事を削除しました");
}

#-----------------------------------------------------------
#  ユーザースレッドロック開閉（解決済）
#-----------------------------------------------------------
sub user_lock {
	# POSTメソッド以外は不受理
	if ($ENV{REQUEST_METHOD} ne 'POST') {
		error("不正なリクエストです");
	}

	# フォーム内容のチェック
	$in{num} =~ s/\D//g;
	if ($in{num} eq '' || $in{pwd} eq '') {
		error("記事NOまたはパスワードの記入モレがあります");
	}

		# ロック情報をマッチングし更新
		my @new;
		open(DAT,"+< $cf{logfile}") or err("open err: $cf{logfile}");
		eval "flock(DAT, 2);";
		my $top = <DAT>;
		while (<DAT>) {
			my ($no,$re,$lx,$sub,$eml,$url,$nam,$dat,$msg,$tim,$ho,$pw,$wr,$oya,$sml,$res,$e1,$w1,$h1,$key,$e2,$w2,$h2,$e3,$w3,$h3,$e4,$w4,$h4,$e5,$w5,$h5,$imgtxt1,$imgtxt2,$imgtxt3,$imgtxt4,$imgtxt5) = split(/<>/);

		if ($in{num} == $no || $in{num} == $oya) {
				$key = $key ? 2 : 1;
				$_ = "$no<>$re<>$lx<>$sub<>$eml<>$url<>$nam<>$dat<>$msg<>$tim<>$ho<>$pw<>$wr<>$oya<>$sml<>$res<>$e1<>$w1<>$h1<>$key<>$e2<>$w2<>$h2<>$e3<>$w3<>$h3<>$e4<>$w4<>$h4<>$e5<>$w5<>$h5<>$imgtxt1<>$imgtxt2<>$imgtxt3<>$imgtxt4<>$imgtxt5<>\n";
			}
			push(@new,$_);
		}

	# 更新
	unshift(@new,$top);
	seek(DAT, 0, 0);
	print DAT @new;
	truncate(DAT, tell(DAT));
	close(DAT);

	# 完了画面
	message("スレッドを解決済にしてロックしました。");
}

#-----------------------------------------------------------
#  メール送信
#-----------------------------------------------------------
sub sendmail {
	my ($count,$host) = @_;

	# 件名をMIMEエンコード
	require './lib/jacode.pl';
	my $msub = mime_unstructured_header("BBS: $in{sub}");

	# メール本文のタグ/改行を復元
	my $msg = $in{message};
	$msg =~ s|<br( /)?>|\n|g;
	$msg =~ s/&lt;/</g;
	$msg =~ s/&gt;/>/g;
	$msg =~ s/&quot;/"/g;
	$msg =~ s/&amp;/&/g;

	my $times = time;
	my $date = get_time();

	# メール本文
	my $mbody = <<MAIL_BODY;
▼掲示板に投稿がありました。

投稿時間：$date
ホスト名：$host

投稿者名：$in{name}
Ｅメール：$in{email}
タイトル：$in{sub}
参照先  ：$in{url}

$msg
MAIL_BODY

	# JISコード変換
	my $body;
	for my $tmp ( split(/\n/,$mbody) ) {
		jcode::convert(\$tmp,'jis','utf8');
		$body .= "$tmp\n";
	}
	
	# FROM行の定義
	my $from = $in{email} || $cf{mailto};
	
	# sendmailコマンド
	my $scmd = "$cf{sendmail} -t -i";
	if ($cf{sendm_f} == 1) { $scmd .= " -f $from"; }
	
	# sendmail起動
	open(MAIL,"| $scmd") or error("メール送信失敗");
	print MAIL "To: $cf{mailto}\n";
	print MAIL "From: $from\n";
	print MAIL "Subject: $msub\n";
	print MAIL "MIME-Version: 1.0\n";
	print MAIL "Content-type: text/plain; charset=ISO-2022-JP\n";
	print MAIL "Content-Transfer-Encoding: 7bit\n";
	print MAIL "X-Mailer: $cf{version}\n\n";
	print MAIL "$body\n";
	close(MAIL);
}

#-----------------------------------------------------------
#  過去ログ生成
#-----------------------------------------------------------
sub make_pastlog {
	my @past = @_;

	# 過去ログNOファイル
	open(NO,"+< $cf{nofile}") or &error("open err: $cf{nofile}");
	eval "flock(NO, 2);";
	my $num = <NO>;

	# 過去ログを定義
	my $pastfile = "$cf{pastdir}/" . sprintf("%04d",$num) . ".cgi";

	# 過去ログを開く
	open(DAT,"+< $pastfile") or &error("open err: $pastfile");
	eval "flock(DAT, 2);";
	my @data = <DAT>;

	# 規定行数オーバー時、次ファイル生成
	if (@data > $cf{max_line}) {

		# 過去ログを閉じる
		@data = ();
		close(DAT);

		# 過去NO更新
		seek(NO, 0, 0);
		print NO ++$num;
		truncate(NO, tell(NO));
		close(NO);

		$pastfile = "$cf{pastdir}/" . sprintf("%04d",$num) . ".cgi";

		open(DAT,"+> $pastfile");
		eval "flock(DAT, 2);";
		print DAT @past;
		close(DAT);

		chmod(0666, $pastfile);

	# 規定内
	} else {

		# 過去NOファイルを閉じる
		close(NO);

		# 過去ログ更新
		seek(DAT, 0, 0);
		print DAT @past;
		print DAT @data;
		truncate(DAT, tell(DAT));
		close(DAT);
	}
}

#-----------------------------------------------------------
#  入力チェック
#-----------------------------------------------------------
sub check_input {
	# 改行カット
	$in{sub}  =~ s/<br>//g;
	$in{name} =~ s/<br>//g;
	$in{pwd}  =~ s/<br>//g;
	$in{captcha} =~ s/<br>//g;
	$in{message} =~ s/(<br>)+$//g;

	# 画像
	if (!$cf{image_upl}) { $in{upfile} = ''; }

	# スパムチェック
	if ($cf{no_wd}) { &no_wd; }
	if ($cf{jp_wd}) { &jp_wd; }
	if ($cf{urlnum} > 0) { &urlnum; }

	# 入力チェック
	my $err;
	if ($in{name} eq "") {
		$err .= "名前の入力モレです<br>";
	} elsif (length($in{name}) > 30) {
		$err .= "名前は全角で15文字までです<br>";
	}
	if ($in{message} eq "") {
		$err .= "コメントの入力モレです<br>";
	}
	if ($in{email} ne '' && $in{email} !~ /^[\w\.\-]+\@[\w\.\-]+\.[a-zA-Z]{2,6}$/) {
		$err .= "E-Mailの入力が不正です<br>";
	}
	if ($in{sub} eq "") {
		$err .= "タイトルの入力モレです<br>";
	} elsif (length($in{sub}) > $cf{sub_length}) {
		$err .= "タイトルは半角で$cf{sub_length}文字までです<br>";
	}
	if ($in{url} eq "http://") {
		$in{url} = "";
	} elsif ($in{url} ne '' && $in{url} !~ /^https?:\/\/[\w-.!~*'();\/?:\@&=+\$,%#]+$/) {
		$err .= "URL情報が不正です<br>";
	}
	if ($err) { error($err); }
}

#-----------------------------------------------------------
#  禁止ワードチェック
#-----------------------------------------------------------
sub no_wd {
	my $flg;
	foreach ( split(/,/, $cf{no_wd}) ) {
		if (index("$in{name} $in{sub} $in{message}",$_) >= 0) {
			$flg++;
			last;
		}
	}
	if ($flg) { error("禁止ワードが含まれています"); }
}

#-----------------------------------------------------------
#  日本語チェック
#-----------------------------------------------------------
sub jp_wd {
	if ($in{message} !~ /(?:[\xC0-\xDF][\x80-\xBF]|[\xE0-\xEF][\x80-\xBF]{2}|[\xF0-\xF7][\x80-\xBF]{3})/x) {
		error("メッセージに日本語が含まれていません");
	}
}

#-----------------------------------------------------------
#  URL個数チェック
#-----------------------------------------------------------
sub urlnum {
	my $com = $in{message};
	my $num = ($com =~ s|(https?://)|$1|ig);
	if ($num > $cf{urlnum}) {
		error("コメント中のURLアドレスは最大$cf{urlnum}個までです");
	}
}

#-----------------------------------------------------------
#  修正フォーム
#-----------------------------------------------------------
sub edit_form {
	my $data = shift;
	my ($no,$re,$lx,$sub,$eml,$url,$nam,$dat,$msg,$lt,$ho,$pw,$wrp,$oya,$sml,$res,$e1,$w1,$h1,$key,$e2,$w2,$h2,$e3,$w3,$h3,$e4,$w4,$h4,$e5,$w5,$h5,$imgtxt1,$imgtxt2,$imgtxt3,$imgtxt4,$imgtxt5) = split(/<>/, $data);
	$msg =~ s|<br( /)?>|\n|g;

	my %ops = (0 =>'表示', 1 =>'非表示');
	my $op_smail;
	foreach (0,1) {
		if ($sml == $_) {
			$op_smail .= qq|<option value="$_" selected>$ops{$_}\n|;
		} else {
			$op_smail .= qq|<option value="$_">$ops{$_}\n|;
		}
	}

	open(IN,"$cf{tmpldir}/edit.html") or &error("open err: edit.html");
	my $tmpl = join('', <IN>);
	close(IN);

	if (!$cf{image_upl}) {
		$tmpl =~ s/<!-- image_begin -->.+<!-- image_end -->//s;
	} elsif ($e1) {
		# 画像編集用
		my $image;
		$image .= qq|&nbsp; [<a href="$cf{uplurl}/$no-1$e1" target="_blank">添付</a>]\n|;
		$image .= qq|<input type="checkbox" name="del1" value="1">削除\n|;

	$tmpl =~ s/<!-- image01 -->/$image/g;
	}

	if (!$cf{image_upl}) {
		$tmpl =~ s/<!-- image_begin -->.+<!-- image_end -->//s;
	} elsif ($e2) {
		# 画像編集用
		my $image;
		$image .= qq|&nbsp; [<a href="$cf{uplurl}/$no-2$e2" target="_blank">添付</a>]\n|;
		$image .= qq|<input type="checkbox" name="del2" value="1">削除\n|;

	$tmpl =~ s/<!-- image02 -->/$image/g;
	}

	if (!$cf{image_upl}) {
		$tmpl =~ s/<!-- image_begin -->.+<!-- image_end -->//s;
	} elsif ($e3) {
		# 画像編集用
		my $image;
		$image .= qq|&nbsp; [<a href="$cf{uplurl}/$no-3$e3" target="_blank">添付</a>]\n|;
		$image .= qq|<input type="checkbox" name="del3" value="1">削除\n|;

	$tmpl =~ s/<!-- image03 -->/$image/g;
	}

	if (!$cf{image_upl}) {
		$tmpl =~ s/<!-- image_begin -->.+<!-- image_end -->//s;
	} elsif ($e4) {
		# 画像編集用
		my $image;
		$image .= qq|&nbsp; [<a href="$cf{uplurl}/$no-4$e4" target="_blank">添付</a>]\n|;
		$image .= qq|<input type="checkbox" name="del4" value="1">削除\n|;

	$tmpl =~ s/<!-- image04 -->/$image/g;
	}

	if (!$cf{image_upl}) {
		$tmpl =~ s/<!-- image_begin -->.+<!-- image_end -->//s;
	} elsif ($e5) {
		# 画像編集用
		my $image;
		$image .= qq|&nbsp; [<a href="$cf{uplurl}/$no-5$e5" target="_blank">添付</a>]\n|;
		$image .= qq|<input type="checkbox" name="del5" value="1">削除\n|;

	$tmpl =~ s/<!-- image05 -->/$image/g;
	}

	$tmpl =~ s/!([a-z]+_cgi)!/$cf{$1}/g;
	$tmpl =~ s/!bbs_title!/$cf{bbs_title}/g;
	$tmpl =~ s|!bbs_css!|$cf{cmnurl}/bbs.css|g;
	$tmpl =~ s|!bbs_js!|$cf{cmnurl}/bbs.js|g;
	$tmpl =~ s/!name!/$nam/g;
	$tmpl =~ s/!email!/$eml/g;
	$tmpl =~ s/!sub!/$sub/g;
	$tmpl =~ s/!msg!/$msg/g;
	$tmpl =~ s/!url!/$url/g;
	$tmpl =~ s/!num!/$in{num}/g;
	$tmpl =~ s/!no!/$no/g;
	$tmpl =~ s/!pwd!/$in{pwd}/g;
	$tmpl =~ s/<!-- op_smail -->/$op_smail/g;
	$tmpl =~ s|!ico:(\w+\.\w+)!|<img src="$cf{icourl}/$1" class="icon">|g;

	if ($e1 eq '') {
		$tmpl =~ s/!imgtxt1!//g;
	} else {
		$tmpl =~ s/!imgtxt1!/$imgtxt1/g;
	}
	if ($e2 eq '') {
		$tmpl =~ s/!imgtxt2!//g;
	} else {
		$tmpl =~ s/!imgtxt2!/$imgtxt2/g;
	}
	if ($e3 eq '') {
		$tmpl =~ s/!imgtxt3!//g;
	} else {
		$tmpl =~ s/!imgtxt3!/$imgtxt3/g;
	}
	if ($e4 eq '') {
		$tmpl =~ s/!imgtxt4!//g;
	} else {
		$tmpl =~ s/!imgtxt4!/$imgtxt4/g;
	}
	if ($e5 eq '') {
		$tmpl =~ s/!imgtxt5!//g;
	} else {
		$tmpl =~ s/!imgtxt5!/$imgtxt5/g;
	}

	print "Content-type: text/html; charset=utf-8\n\n";
	print $tmpl;

	# フッタ
	footer();

	exit;
}

#-----------------------------------------------------------
#  タグ復元
#-----------------------------------------------------------
sub tag {
	local($_) = @_;

	# 変換
	s/&lt;/</g;
	s/&gt;/>/g;
	s/&amp;/&/g;
	s/&quot;/"/g;
	$_;
}

#-----------------------------------------------------------
#  完了メッセージ画面
#-----------------------------------------------------------
sub message {
	my $msg = shift;

	open(IN,"$cf{tmpldir}/mesg.html") or &error("open err: mesg.html");
	my $tmpl = join('', <IN>);
	close(IN);

	$tmpl =~ s/!message!/$msg/;
	$tmpl =~ s/!bbs_cgi!/$cf{bbs_cgi}/;
	$tmpl =~ s/!bbs_title!/$cf{bbs_title}/g;
	$tmpl =~ s|!bbs_css!|$cf{cmnurl}/bbs.css|g;
	$tmpl =~ s|!bbs_js!|$cf{cmnurl}/bbs.js|g;
	$tmpl =~ s|!ico:(\w+\.\w+)!|<img src="$cf{icourl}/$1">|g;

	print "Content-type: text/html; charset=utf-8\n\n";
	print $tmpl;

	# フッタ
	footer();

	exit;
}

#-----------------------------------------------------------
#  ホストチェック
#-----------------------------------------------------------
sub check_host {
	# IP/ホスト取得
	my $host = $ENV{REMOTE_HOST};
	my $addr = $ENV{REMOTE_ADDR};
	if ($cf{gethostbyaddr} && ($host eq "" || $host eq $addr)) {
		$host = gethostbyaddr(pack("C4", split(/\./, $addr)), 2);
	}

	# IPチェック
	my $flg;
	foreach ( split(/\s+/, $cf{deny_addr}) ) {
		s/\./\\\./g;
		s/\*/\.\*/g;

		if ($addr =~ /^$_/i) { $flg++; last; }
	}
	if ($flg) {
		error("アクセスを許可されていません");

	# ホストチェック
	} elsif ($host) {

		foreach ( split(/\s+/, $cf{deny_host}) ) {
			s/\./\\\./g;
			s/\*/\.\*/g;

			if ($host =~ /$_$/i) { $flg++; last; }
		}
		if ($flg) {
			error("アクセスを許可されていません");
		}
	}
	$host ||= $addr;

	return ($host,$addr);
}

#-----------------------------------------------------------
#  crypt暗号
#-----------------------------------------------------------
sub encrypt {
	my $in = shift;

	my @wd = ('a'..'z', 'A'..'Z', '0'..'9', '.', '/');
	srand;
	my $salt = $wd[int(rand(@wd))] . $wd[int(rand(@wd))];
	crypt($in, $salt) || crypt ($in, '$1$' . $salt);
}

#-----------------------------------------------------------
#  crypt照合
#-----------------------------------------------------------
sub decrypt {
	my ($in,$dec) = @_;

	my $salt = $dec =~ /^\$1\$(.*)\$/ ? $1 : substr($dec, 0, 2);
	if (crypt($in, $salt) eq $dec || crypt($in, '$1$' . $salt) eq $dec) {
		return 1;
	} else {
		return 0;
	}
}

#-----------------------------------------------------------
#  参照フォームクッキー発行(新規投稿)
#-----------------------------------------------------------
sub ref_set_cookie {
	my (@data,$ref_no) = @_;
	
	my ($sec,$min,$hour,$mday,$mon,$year,$wday,undef,undef) = gmtime(time + 60*24*60*60);
	my @mon  = qw|Jan Feb Mar Apr May Jun Jul Aug Sep Oct Nov Dec|;
	my @week = qw|Sun Mon Tue Wed Thu Fri Sat|;
	
	# 時刻フォーマット
	my $gmt = sprintf("%s, %02d-%s-%04d %02d:%02d:%02d GMT",
				$week[$wday],$mday,$mon[$mon],$year+1900,$hour,$min,$sec);
	
	# URLエンコード
	my $cook;
	foreach (@data) {
		s/(\W)/sprintf("%%%02X", unpack("C", $1))/eg;
		$cook .= "$_<>";
	}

	if ($ref_no == 0) { $ref_no = "0"; }

	print "Set-Cookie: $cf{cookie_id2}=$cook; expires=$gmt\n";
}

#-----------------------------------------------------------
#  参照フォームクッキー発行(返信投稿)
#-----------------------------------------------------------
sub refres_set_cookie {
	my (@data,$ref_no) = @_;
	
	my ($sec,$min,$hour,$mday,$mon,$year,$wday,undef,undef) = gmtime(time + 60*24*60*60);
	my @mon  = qw|Jan Feb Mar Apr May Jun Jul Aug Sep Oct Nov Dec|;
	my @week = qw|Sun Mon Tue Wed Thu Fri Sat|;
	
	# 時刻フォーマット
	my $gmt = sprintf("%s, %02d-%s-%04d %02d:%02d:%02d GMT",
				$week[$wday],$mday,$mon[$mon],$year+1900,$hour,$min,$sec);
	
	# URLエンコード
	my $cook;
	foreach (@data) {
		s/(\W)/sprintf("%%%02X", unpack("C", $1))/eg;
		$cook .= "$_<>";
	}

	if ($ref_no == 0) { $ref_no = "0"; }

	print "Set-Cookie: $cf{cookie_id4}=$cook; expires=$gmt\n";
}

#-----------------------------------------------------------
#  クッキー発行
#-----------------------------------------------------------
sub set_cookie {
	my @data = @_;

	my ($sec,$min,$hour,$mday,$mon,$year,$wday,undef,undef) = gmtime(time + 60*24*60*60);
	my @mon  = qw|Jan Feb Mar Apr May Jun Jul Aug Sep Oct Nov Dec|;
	my @week = qw|Sun Mon Tue Wed Thu Fri Sat|;

	# 時刻フォーマット
	my $gmt = sprintf("%s, %02d-%s-%04d %02d:%02d:%02d GMT",
				$week[$wday],$mday,$mon[$mon],$year+1900,$hour,$min,$sec);

	# URLエンコード
	my $cook;
	foreach (@data) {
		s/(\W)/sprintf("%%%02X", unpack("C", $1))/eg;
		$cook .= "$_<>";
	}

	print "Set-Cookie: $cf{cookie_id}=$cook; expires=$gmt\n";
}

#-----------------------------------------------------------
#  添付アップロード
#-----------------------------------------------------------
sub upload {
	my $no = shift;
	
	# サムネイル機能
	require './lib/thumb.pl' if ($cf{thumbnail});

	my @ret;
	foreach my $i (1 .. 5) {

		# mimeタイプ
		my $mime = $cgi->param_mime("upfile$i");

		# 拡張子取得
		my $fname = $cgi->param_filename("upfile$i");
		if ($fname =~ /(\.jpe?g|\.png|\.gif|\.pdf|\.txt|\.doc|\.docx|\.xls|\.xlsx|\.ppt|\.pptx|\.zip|\.mp3|\.mp4)$/i) {
			my $ex = $1;
			$ex =~ tr/A-Z/a-z/;
			if ($ex eq '.jpeg') { $ex = '.jpg'; }

			# 整合性チェック
			my $flg;
			if ($cf{ok_gif}) {
				if ($mime =~ /^image\/gif$/i and $ex eq '.gif') { $flg++; }
			}
			if (!$flg and $cf{ok_jpeg}) {
				if ($mime =~ /^image\/p?jpe?g$/i and $ex eq '.jpg') { $flg++; }
			}
			if (!$flg and $cf{ok_png}) {
				if ($mime =~ /^image\/(x-)?png$/i and $ex eq '.png') { $flg++; }
			}
			if (!$flg and $cf{ok_pdf}) {
				if ($mime =~ /^application\/pdf$/i and $ex eq '.pdf') { $flg++; }
			}
			if (!$flg and $cf{ok_zip}) {
				if ($mime =~ /^application\/(x-)?zip(-compressed)?$/i and $ex eq '.zip') { $flg++; }
			}
			if (!$flg and $cf{ok_text}) {
				if ($mime =~ /^text\/plain$/i and $ex =~ /^\.te?xt$/) { $flg++; }
			}
			if (!$flg and $cf{ok_word}) {
				if ($mime =~ /^application\/(vnd\.)?ms-?word$/i and $ex eq '.doc') { $flg++; }
				elsif ($mime =~ /^application\/vnd\.openxmlformats-officedocument\.wordprocessingml\.document$/i and $ex eq '.docx') { $flg++; }
			}
			if (!$flg and $cf{ok_excel}) {
				if ($mime =~ /^application\/(vnd\.)?ms-?excel$/i and $ex eq '.xls') { $flg++; }
				elsif ($mime =~ /^application\/vnd\.openxmlformats-officedocument\.spreadsheetml\.sheet$/i and $ex eq '.xlsx') { $flg++; }
			}
			if (!$flg and $cf{ok_ppt}) {
				if ($mime =~ /^application\/(vnd\.)?ms-?powerpoint$/i and $ex eq '.ppt') { $flg++; }
				elsif ($mime =~ /^application\/vnd\.openxmlformats-officedocument\.presentationml\.presentation$/i and $ex eq '.pptx') { $flg++; }
			}
			if (!$flg and $cf{ok_mp3}) {
				if ($mime =~ /^audio\/mpeg$/i and $ex eq '.mp3') { $flg++; }
				elsif ($mime =~ /^audio\/mp3/i and $ex eq '.mp3') { $flg++; }
				elsif ($mime =~ /^audio\/mpg/i and $ex eq '.mp3') { $flg++; }
			}
			if (!$flg and $cf{ok_mp4}) {
				if ($mime =~ /^video\/mpeg$/i and $ex eq '.mp4') { $flg++; }
				elsif ($mime =~ /^video\/mp4/i and $ex eq '.mp4') { $flg++; }
				elsif ($mime =~ /^video\/mpg/i and $ex eq '.mp4') { $flg++; }
			}
			if (!$flg) { error('このファイルは取り扱いできません'); }

		# 添付ファイル定義
		my $upfile = "$cf{upldir}/$no-$i$ex";

		# アップロード書き込み
		open(UP,"+> $upfile") or error("up err: $upfile");
		binmode(UP);
		print UP $in{"upfile$i"};
		close(UP);

		# パーミッション付与
		chmod(0666,$upfile);

		# 画像の場合サイズ取得
		my ($flg,$w,$h);
		if ($ex eq ".jpg") { ($w,$h) = j_size($upfile); $flg++; }
		elsif ($ex eq ".gif") { ($w,$h) = g_size($upfile); $flg++; }
		elsif ($ex eq ".png") { ($w,$h) = p_size($upfile); $flg++; }

		# サムネイル作成
		if ($flg && $cf{thumbnail}) {
			($w,$h) = resize($w,$h);
			my $thumb = "$cf{upldir}/$no-s-$i$ex";
			make_thumb($upfile,$thumb,$w,$h);
		}

		# 拡張子, 横幅, 縦幅 の順
			push(@ret,($ex,$w,$h));
		} else {
			push(@ret,('','',''));
		}
	}
	# 結果を返す
	return @ret;
}

#-----------------------------------------------------------
#  JPEGサイズ認識
#-----------------------------------------------------------
sub j_size {
	my $jpg = shift;

	my ($h, $w, $t);
	open(IMG,"$jpg");
	binmode(IMG);
	read(IMG, $t, 2);
	while (1) {
		read(IMG, $t, 4);
		my ($m, $c, $l) = unpack("a a n", $t);

		if ($m ne "\xFF") {
			$w = $h = 0;
			last;
		} elsif ((ord($c) >= 0xC0) && (ord($c) <= 0xC3)) {
			read(IMG, $t, 5);
			($h, $w) = unpack("xnn", $t);
			last;
		} else {
			read(IMG, $t, ($l - 2));
		}
	}
	close(IMG);

	return ($w, $h);
}

#-----------------------------------------------------------
#  GIFサイズ認識
#-----------------------------------------------------------
sub g_size {
	my $gif = shift;

	my $data;
	open(IMG,"$gif");
	binmode(IMG);
	sysread(IMG, $data, 10);
	close(IMG);

	if ($data =~ /^GIF/) { $data = substr($data, -4); }
	my $w = unpack("v", substr($data, 0, 2));
	my $h = unpack("v", substr($data, 2, 2));

	return ($w, $h);
}

#-----------------------------------------------------------
#  PNGサイズ認識
#-----------------------------------------------------------
sub p_size {
	my $png = shift;

	my $data;
	open(IMG,"$png");
	binmode(IMG);
	read(IMG, $data, 24);
	close(IMG);

	my $w = unpack("N", substr($data, 16, 20));
	my $h = unpack("N", substr($data, 20, 24));

	return ($w, $h);
}

#-----------------------------------------------------------
#  mimeエンコード
#  [quote] http://www.din.or.jp/~ohzaki/perl.htm#JP_Base64
#-----------------------------------------------------------
sub mime_unstructured_header {
  my $oldheader = shift;
  jcode::convert(\$oldheader,'euc','utf8');
  my ($header,@words,@wordstmp,$i);
  my $crlf = $oldheader =~ /\n$/;
  $oldheader =~ s/\s+$//;
  @wordstmp = split /\s+/, $oldheader;
  for ($i = 0; $i < $#wordstmp; $i++) {
    if ($wordstmp[$i] !~ /^[\x21-\x7E]+$/ and
	$wordstmp[$i + 1] !~ /^[\x21-\x7E]+$/) {
      $wordstmp[$i + 1] = "$wordstmp[$i] $wordstmp[$i + 1]";
    } else {
      push(@words, $wordstmp[$i]);
    }
  }
  push(@words, $wordstmp[-1]);
  foreach my $word (@words) {
    if ($word =~ /^[\x21-\x7E]+$/) {
      $header =~ /(?:.*\n)*(.*)/;
      if (length($1) + length($word) > 76) {
	$header .= "\n $word";
      } else {
	$header .= $word;
      }
    } else {
      $header = add_encoded_word($word, $header);
    }
    $header =~ /(?:.*\n)*(.*)/;
    if (length($1) == 76) {
      $header .= "\n ";
    } else {
      $header .= ' ';
    }
  }
  $header =~ s/\n? $//mg;
  $crlf ? "$header\n" : $header;
}
sub add_encoded_word {
  my ($str, $line) = @_;
  my $result;
  my $ascii = '[\x00-\x7F]';
  my $twoBytes = '[\x8E\xA1-\xFE][\xA1-\xFE]';
  my $threeBytes = '\x8F[\xA1-\xFE][\xA1-\xFE]';
  while (length($str)) {
    my $target = $str;
    $str = '';
    if (length($line) + 22 +
	($target =~ /^(?:$twoBytes|$threeBytes)/o) * 8 > 76) {
      $line =~ s/[ \t\n\r]*$/\n/;
      $result .= $line;
      $line = ' ';
    }
    while (1) {
      my $encoded = '=?ISO-2022-JP?B?' .
      b64encode(jcode::jis($target,'euc','z')) . '?=';
      if (length($encoded) + length($line) > 76) {
	$target =~ s/($threeBytes|$twoBytes|$ascii)$//o;
	$str = $1 . $str;
      } else {
	$line .= $encoded;
	last;
      }
    }
  }
  $result . $line;
}
# [quote] http://www.tohoho-web.com/perl/encode.htm
sub b64encode {
    my $buf = shift;
    my ($mode,$tmp,$ret);
    my $b64 = "ABCDEFGHIJKLMNOPQRSTUVWXYZ"
                . "abcdefghijklmnopqrstuvwxyz"
                . "0123456789+/";
	
    $mode = length($buf) % 3;
    if ($mode == 1) { $buf .= "\0\0"; }
    if ($mode == 2) { $buf .= "\0"; }
    $buf =~ s/(...)/{
        $tmp = unpack("B*", $1);
        $tmp =~ s|(......)|substr($b64, ord(pack("B*", "00$1")), 1)|eg;
        $ret .= $tmp;
    }/eg;
    if ($mode == 1) { $ret =~ s/..$/==/; }
    if ($mode == 2) { $ret =~ s/.$/=/; }
    
    return $ret;
}

#-----------------------------------------------------------
#  文字数カウント for UTF-8
#-----------------------------------------------------------
sub count_str {
	my ($str) = @_;
	
	# UTF-8定義
	my $byte1 = '[\x00-\x7f]';
	my $byte2 = '[\xC0-\xDF][\x80-\xBF]';
	my $byte3 = '[\xE0-\xEF][\x80-\xBF]{2}';
	my $byte4 = '[\xF0-\xF7][\x80-\xBF]{3}';
	
	my $i = 0;
	while ($str =~ /($byte1|$byte2|$byte3|$byte4)/gx) {
		$i++;
	}
	return $i;
}

